Index: /trunk/src/VBox/ValidationKit/ValidationKitCodingGuidelines.cpp
===================================================================
--- /trunk/src/VBox/ValidationKit/ValidationKitCodingGuidelines.cpp	(revision 103544)
+++ /trunk/src/VBox/ValidationKit/ValidationKitCodingGuidelines.cpp	(revision 103545)
@@ -48,5 +48,5 @@
  *
  * Type prefixes:
- *      - 'b' for byte (octect).
+ *      - 'b' for byte (octet).
  *      - 'ch' for a single character.
  *      - 'f' for boolean and flags.
@@ -68,5 +68,5 @@
  *
  * Other qualifiers:
- *      - 'c' for a count. Implies integer or long integer type. Higest
+ *      - 'c' for a count. Implies integer or long integer type. Highest
  *        priority.
  *      - 'sec' for a second value. Implies long integer type.
Index: /trunk/src/VBox/ValidationKit/tests/storage/storagecfg.py
===================================================================
--- /trunk/src/VBox/ValidationKit/tests/storage/storagecfg.py	(revision 103544)
+++ /trunk/src/VBox/ValidationKit/tests/storage/storagecfg.py	(revision 103545)
@@ -125,8 +125,7 @@
             asPools = sOutput.splitlines();
             for sPool in asPools:
-                if sPool.startswith(sPoolIdStart):
-                    # Extract the whole name and add it to the list.
-                    asItems = sPool.split('\t');
-                    lstPools.append(asItems[0]);
+                oMatchResult = re.match("%s[0-9]?[0-9]?" % sPoolIdStart, sPool)  # either re.Match obj or None
+                if oMatchResult:
+                    lstPools.append(oMatchResult.group(0));
         return lstPools;
 
@@ -142,8 +141,7 @@
             asVolumes = sOutput.splitlines();
             for sVolume in asVolumes:
-                if sVolume.startswith(sPool + '/' + sVolumeIdStart):
-                    # Extract the whole name and add it to the list.
-                    asItems = sVolume.split('\t');
-                    lstVolumes.append(asItems[0]);
+                oMatchResult = re.match("%s/%s" % (sPool, sVolumeIdStart), sVolume)  # either re.Match obj or None
+                if oMatchResult:
+                    lstVolumes.append(oMatchResult.group(0));
         return lstVolumes;
 
@@ -495,5 +493,5 @@
                 self.lstDisks = oStorOs.getDisksMatchingRegExp(oDiskCfg.getDisks());
             elif oDiskCfg.isCfgList():
-                # Assume a list of of disks and add.
+                # Assume a list of disks and add.
                 for sDisk in oDiskCfg.getDisks():
                     self.lstDisks.append(StorageDisk(sDisk));
@@ -679,5 +677,5 @@
     def cleanupLeftovers(self):
         """
-        Tries to cleanup any leftover pools and volumes from a failed previous run.
+        Tries to clean up any leftover pools and volumes from a failed previous run.
         """
         reporter.log('cleanupLeftovers starts');
@@ -686,6 +684,8 @@
 
         fRc = True;
-        if os.path.exists(self.oDiskCfg.getDisks()):
-            for sEntry in os.listdir(self.oDiskCfg.getDisks()):
+        asDisks = self.oDiskCfg.getDisks();
+        reporter.log("oDiskCfg.getDisks: %s" % asDisks);
+        if os.path.exists(asDisks):
+            for sEntry in os.listdir(asDisks):
                 fRc = fRc and self.oExec.rmTree(os.path.join(self.oDiskCfg.getDisks(), sEntry));
         reporter.log('cleanupLeftovers ends');
Index: /trunk/src/VBox/ValidationKit/tests/storage/tdStorageBenchmark1.py
===================================================================
--- /trunk/src/VBox/ValidationKit/tests/storage/tdStorageBenchmark1.py	(revision 103544)
+++ /trunk/src/VBox/ValidationKit/tests/storage/tdStorageBenchmark1.py	(revision 103545)
@@ -494,5 +494,5 @@
         'testboxstor1.de.oracle.com': (True, storagecfg.DiskCfg('solaris', storagecfg.g_ksDiskCfgRegExp, r'c[3-9]t\dd0\Z')),
         # Windows testbox doesn't return testboxstor2.de.oracle.com from socket.getfqdn()
-        'testboxstor2':               (False, storagecfg.DiskCfg('win',     storagecfg.g_ksDiskCfgStatic, 'D:\\StorageTest')),
+        'testboxstor2':               (False, storagecfg.DiskCfg('win', storagecfg.g_ksDiskCfgStatic, 'D:/StorageTest')),
 
         # Local test configs for the testcase developer