Index: trunk/doc/manual/ru_RU/man_VBoxManage-modifynvram.xml
===================================================================
--- trunk/doc/manual/ru_RU/man_VBoxManage-modifynvram.xml	(revision 103454)
+++ trunk/doc/manual/ru_RU/man_VBoxManage-modifynvram.xml	(revision 103617)
@@ -49,32 +49,72 @@
     <cmdsynopsis id="synopsis-vboxmanage-modifynvram-inituefivarstore">
       <command>VBoxManage modifynvram</command>
-      <arg choice="req"><replaceable>uuid|имя-ВМ</replaceable></arg>
+      <group choice="req">
+        <arg choice="plain"><replaceable>uuid</replaceable></arg>
+        <arg choice="plain"><replaceable>имя-ВМ</replaceable></arg>
+      </group>
       <arg choice="plain">inituefivarstore</arg>
     </cmdsynopsis>
     <cmdsynopsis id="synopsis-vboxmanage-modifynvram-enrollmssignatures">
       <command>VBoxManage modifynvram</command>
-      <arg choice="req"><replaceable>uuid|имя-ВМ</replaceable></arg>
+      <group choice="req">
+        <arg choice="plain"><replaceable>uuid</replaceable></arg>
+        <arg choice="plain"><replaceable>имя-ВМ</replaceable></arg>
+      </group>
       <arg choice="plain">enrollmssignatures</arg>
     </cmdsynopsis>
     <cmdsynopsis id="synopsis-vboxmanage-modifynvram-enrollorclpk">
       <command>VBoxManage modifynvram</command>
-      <arg choice="req"><replaceable>uuid|имя-ВМ</replaceable></arg>
+      <group choice="req">
+        <arg choice="plain"><replaceable>uuid</replaceable></arg>
+        <arg choice="plain"><replaceable>имя-ВМ</replaceable></arg>
+      </group>
       <arg choice="plain">enrollorclpk</arg>
     </cmdsynopsis>
     <cmdsynopsis id="synopsis-vboxmanage-modifynvram-enrollpk">
       <command>VBoxManage modifynvram</command>
-      <arg choice="req"><replaceable>uuid|имя-ВМ</replaceable></arg>
+      <group choice="req">
+        <arg choice="plain"><replaceable>uuid</replaceable></arg>
+        <arg choice="plain"><replaceable>имя-ВМ</replaceable></arg>
+      </group>
       <arg choice="plain">enrollpk</arg>
       <arg>--platform-key=<replaceable>имя-файла</replaceable></arg>
       <arg>--owner-uuid=<replaceable>uuid</replaceable></arg>
     </cmdsynopsis>
+    <cmdsynopsis id="synopsis-vboxmanage-modifynvram-enrollmok">
+      <command>VBoxManage modifynvram</command>
+      <group choice="req">
+        <arg choice="plain"><replaceable>uuid</replaceable></arg>
+        <arg choice="plain"><replaceable>имя-ВМ</replaceable></arg>
+      </group>
+      <arg choice="plain">enrollmok</arg>
+      <arg>--mok=<replaceable>имя-файла</replaceable></arg>
+      <arg>--owner-uuid=<replaceable>uuid</replaceable></arg>
+    </cmdsynopsis>
+    <cmdsynopsis id="synopsis-vboxmanage-modifynvram-secureboot">
+      <command>VBoxManage modifynvram</command>
+      <group choice="req">
+        <arg choice="plain"><replaceable>uuid</replaceable></arg>
+        <arg choice="plain"><replaceable>имя-ВМ</replaceable></arg>
+      </group>
+      <arg choice="plain">secureboot</arg>
+      <group choice="req">
+        <arg choice="plain">--enable</arg>
+        <arg choice="plain">--disable</arg>
+      </group>
+    </cmdsynopsis>
     <cmdsynopsis id="synopsis-vboxmanage-modifynvram-listvars">
       <command>VBoxManage modifynvram</command>
-      <arg choice="req"><replaceable>uuid|имя-ВМ</replaceable></arg>
+      <group choice="req">
+        <arg choice="plain"><replaceable>uuid</replaceable></arg>
+        <arg choice="plain"><replaceable>имя-ВМ</replaceable></arg>
+      </group>
       <arg choice="plain">listvars</arg>
     </cmdsynopsis>
     <cmdsynopsis id="synopsis-vboxmanage-modifynvram-queryvar">
       <command>VBoxManage modifynvram</command>
-      <arg choice="req"><replaceable>uuid|имя-ВМ</replaceable></arg>
+      <group choice="req">
+        <arg choice="plain"><replaceable>uuid</replaceable></arg>
+        <arg choice="plain"><replaceable>имя-ВМ</replaceable></arg>
+      </group>
       <arg choice="plain">queryvar</arg>
       <arg>--name=<replaceable>имя</replaceable></arg>
@@ -83,5 +123,8 @@
     <cmdsynopsis id="synopsis-vboxmanage-modifynvram-deletevar">
       <command>VBoxManage modifynvram</command>
-      <arg choice="req"><replaceable>uuid|имя-ВМ</replaceable></arg>
+      <group choice="req">
+        <arg choice="plain"><replaceable>uuid</replaceable></arg>
+        <arg choice="plain"><replaceable>имя-ВМ</replaceable></arg>
+      </group>
       <arg choice="plain">deletevar</arg>
       <arg>--name=<replaceable>имя</replaceable></arg>
@@ -90,5 +133,8 @@
     <cmdsynopsis id="synopsis-vboxmanage-modifynvram-changevar">
       <command>VBoxManage modifynvram</command>
-      <arg choice="req"><replaceable>uuid|имя-ВМ</replaceable></arg>
+      <group choice="req">
+        <arg choice="plain"><replaceable>uuid</replaceable></arg>
+        <arg choice="plain"><replaceable>имя-ВМ</replaceable></arg>
+      </group>
       <arg choice="plain">changevar</arg>
       <arg>--name=<replaceable>имя</replaceable></arg>
@@ -161,4 +207,25 @@
           <term><option>--owner-uuid=<replaceable>uuid</replaceable></option></term>
           <listitem><para>UUID идентифицирующий владельца ключа платформы.</para>
+          </listitem>
+        </varlistentry>
+      </variablelist>
+    </refsect2>
+
+    <refsect2 id="vboxmanage-modifynvram-secureboot">
+      <title>modifynvram secureboot</title>
+      <remark role="help-copy-synopsis"/>
+      <para>
+        Включает или отключает безопасную загрузку UEFI.
+      </para>
+      <variablelist>
+        <varlistentry>
+          <term><option>--enable></option></term>
+          <listitem><para>Включает безопасную загрузку UEFI, если позволяет
+            состояние регистрации ключа.</para>
+          </listitem>
+        </varlistentry>
+        <varlistentry>
+          <term><option>--disable></option></term>
+          <listitem><para>Отключает безопасную загрузку UEFI.</para>
           </listitem>
         </varlistentry>