Index: trunk/src/VBox/GuestHost/SharedClipboard/ClipboardStreamImpl-win.cpp
===================================================================
--- trunk/src/VBox/GuestHost/SharedClipboard/ClipboardStreamImpl-win.cpp	(revision 103480)
+++ trunk/src/VBox/GuestHost/SharedClipboard/ClipboardStreamImpl-win.cpp	(revision 103631)
@@ -60,6 +60,6 @@
 
 
-SharedClipboardWinStreamImpl::SharedClipboardWinStreamImpl(SharedClipboardWinDataObject *pParent, PSHCLTRANSFER pTransfer,
-                                                           const Utf8Str &strPath, PSHCLFSOBJINFO pObjInfo)
+ShClWinStreamImpl::ShClWinStreamImpl(ShClWinDataObject *pParent, PSHCLTRANSFER pTransfer,
+                                     const Utf8Str &strPath, PSHCLFSOBJINFO pObjInfo)
     : m_pParent(pParent)
     , m_lRefCount(1) /* Our IDataObjct *always* holds the last reference to this object; needed for the callbacks. */
@@ -81,5 +81,5 @@
 }
 
-SharedClipboardWinStreamImpl::~SharedClipboardWinStreamImpl(void)
+ShClWinStreamImpl::~ShClWinStreamImpl(void)
 {
     LogFlowThisFuncEnter();
@@ -95,5 +95,5 @@
  */
 
-STDMETHODIMP SharedClipboardWinStreamImpl::QueryInterface(REFIID iid, void **ppvObject)
+STDMETHODIMP ShClWinStreamImpl::QueryInterface(REFIID iid, void **ppvObject)
 {
     AssertPtrReturn(ppvObject, E_INVALIDARG);
@@ -124,5 +124,5 @@
 }
 
-STDMETHODIMP_(ULONG) SharedClipboardWinStreamImpl::AddRef(void)
+STDMETHODIMP_(ULONG) ShClWinStreamImpl::AddRef(void)
 {
     LONG lCount = InterlockedIncrement(&m_lRefCount);
@@ -131,5 +131,5 @@
 }
 
-STDMETHODIMP_(ULONG) SharedClipboardWinStreamImpl::Release(void)
+STDMETHODIMP_(ULONG) ShClWinStreamImpl::Release(void)
 {
     LONG lCount = InterlockedDecrement(&m_lRefCount);
@@ -148,5 +148,5 @@
  */
 
-STDMETHODIMP SharedClipboardWinStreamImpl::Clone(IStream** ppStream)
+STDMETHODIMP ShClWinStreamImpl::Clone(IStream** ppStream)
 {
     RT_NOREF(ppStream);
@@ -156,5 +156,5 @@
 }
 
-STDMETHODIMP SharedClipboardWinStreamImpl::Commit(DWORD dwFrags)
+STDMETHODIMP ShClWinStreamImpl::Commit(DWORD dwFrags)
 {
     RT_NOREF(dwFrags);
@@ -164,5 +164,5 @@
 }
 
-STDMETHODIMP SharedClipboardWinStreamImpl::CopyTo(IStream *pDestStream, ULARGE_INTEGER nBytesToCopy, ULARGE_INTEGER *nBytesRead,
+STDMETHODIMP ShClWinStreamImpl::CopyTo(IStream *pDestStream, ULARGE_INTEGER nBytesToCopy, ULARGE_INTEGER *nBytesRead,
                                                   ULARGE_INTEGER *nBytesWritten)
 {
@@ -173,5 +173,5 @@
 }
 
-STDMETHODIMP SharedClipboardWinStreamImpl::LockRegion(ULARGE_INTEGER nStart, ULARGE_INTEGER nBytes,DWORD dwFlags)
+STDMETHODIMP ShClWinStreamImpl::LockRegion(ULARGE_INTEGER nStart, ULARGE_INTEGER nBytes,DWORD dwFlags)
 {
     RT_NOREF(nStart, nBytes, dwFlags);
@@ -182,5 +182,5 @@
 
 /* Note: Windows seems to assume EOF if nBytesRead < nBytesToRead. */
-STDMETHODIMP SharedClipboardWinStreamImpl::Read(void *pvBuffer, ULONG nBytesToRead, ULONG *nBytesRead)
+STDMETHODIMP ShClWinStreamImpl::Read(void *pvBuffer, ULONG nBytesToRead, ULONG *nBytesRead)
 {
     LogFlowThisFunc(("Enter: m_cbProcessed=%RU64\n", m_cbProcessed));
@@ -249,5 +249,5 @@
 
             if (m_pParent)
-                m_pParent->SetStatus(SharedClipboardWinDataObject::Completed);
+                m_pParent->SetStatus(ShClWinDataObject::Completed);
         }
     }
@@ -256,5 +256,5 @@
     {
         if (m_pParent)
-            m_pParent->SetStatus(SharedClipboardWinDataObject::Error, rc /* Propagate rc */);
+            m_pParent->SetStatus(ShClWinDataObject::Error, rc /* Propagate rc */);
     }
 
@@ -271,11 +271,11 @@
 }
 
-STDMETHODIMP SharedClipboardWinStreamImpl::Revert(void)
-{
-    LogFlowThisFuncEnter();
-    return E_NOTIMPL;
-}
-
-STDMETHODIMP SharedClipboardWinStreamImpl::Seek(LARGE_INTEGER nMove, DWORD dwOrigin, ULARGE_INTEGER* nNewPos)
+STDMETHODIMP ShClWinStreamImpl::Revert(void)
+{
+    LogFlowThisFuncEnter();
+    return E_NOTIMPL;
+}
+
+STDMETHODIMP ShClWinStreamImpl::Seek(LARGE_INTEGER nMove, DWORD dwOrigin, ULARGE_INTEGER* nNewPos)
 {
     RT_NOREF(nMove, dwOrigin, nNewPos);
@@ -286,5 +286,5 @@
 }
 
-STDMETHODIMP SharedClipboardWinStreamImpl::SetSize(ULARGE_INTEGER nNewSize)
+STDMETHODIMP ShClWinStreamImpl::SetSize(ULARGE_INTEGER nNewSize)
 {
     RT_NOREF(nNewSize);
@@ -294,5 +294,5 @@
 }
 
-STDMETHODIMP SharedClipboardWinStreamImpl::Stat(STATSTG *pStatStg, DWORD dwFlags)
+STDMETHODIMP ShClWinStreamImpl::Stat(STATSTG *pStatStg, DWORD dwFlags)
 {
     HRESULT hr = S_OK;
@@ -355,5 +355,5 @@
 }
 
-STDMETHODIMP SharedClipboardWinStreamImpl::UnlockRegion(ULARGE_INTEGER nStart, ULARGE_INTEGER nBytes, DWORD dwFlags)
+STDMETHODIMP ShClWinStreamImpl::UnlockRegion(ULARGE_INTEGER nStart, ULARGE_INTEGER nBytes, DWORD dwFlags)
 {
     RT_NOREF(nStart, nBytes, dwFlags);
@@ -363,5 +363,5 @@
 }
 
-STDMETHODIMP SharedClipboardWinStreamImpl::Write(const void *pvBuffer, ULONG nBytesToRead, ULONG *nBytesRead)
+STDMETHODIMP ShClWinStreamImpl::Write(const void *pvBuffer, ULONG nBytesToRead, ULONG *nBytesRead)
 {
     RT_NOREF(pvBuffer, nBytesToRead, nBytesRead);
@@ -386,5 +386,5 @@
  */
 /* static */
-HRESULT SharedClipboardWinStreamImpl::Create(SharedClipboardWinDataObject *pParent, PSHCLTRANSFER pTransfer,
+HRESULT ShClWinStreamImpl::Create(ShClWinDataObject *pParent, PSHCLTRANSFER pTransfer,
                                              const Utf8Str &strPath, PSHCLFSOBJINFO pObjInfo,
                                              IStream **ppStream)
@@ -392,5 +392,5 @@
     AssertPtrReturn(pTransfer, E_POINTER);
 
-    SharedClipboardWinStreamImpl *pStream = new SharedClipboardWinStreamImpl(pParent, pTransfer, strPath, pObjInfo);
+    ShClWinStreamImpl *pStream = new ShClWinStreamImpl(pParent, pTransfer, strPath, pObjInfo);
     if (pStream)
     {